package renderModels

import (
	asuModels "devel.mephi.ru/dyokunev/go-asu-models"
)

type Formular struct {
	asuModels.Formular
	Person   *Person
	Unit     *Unit
	IsActive bool
}

func NewFormular(in asuModels.Formular) (out Formular) {
	out.Formular = in
	out.IsActive = in.PrepareIsActive().IsActive()

	if in.IsPersonReady() {
		person := NewPersonFromASU(in.GetPerson())
		out.Person = &person
	}
	if in.IsUnitReady() {
		unit := NewUnit(in.GetUnit())
		out.Unit = &unit
	}

	return
}

type Formulars []Formular

func NewFormulars(in asuModels.Formulars) (out Formulars) {
	for _, inFormular := range in {
		out = append(out, NewFormular(inFormular))
	}

	return
}
