package renderModels

import (
	models "devel.mephi.ru/dyokunev/cps-models"
	asuModels "devel.mephi.ru/dyokunev/go-asu-models"
	sdModels11 "devel.mephi.ru/dyokunev/go-sd-models/api11"
)

type Person struct {
	sdModels11.Person
	Formulars Formulars
	Passes    []models.Pass
}

func NewPersonFromASU(in asuModels.Person) (out Person) {
	out.Person = sdModels11.Person{
		Fullname: in.Lastname + " " + in.Firstname,
		PersonId: sdModels11.PersonId{
			EmpGUID: &in.EmpGUID,
		},
	}
	if in.Patronymic != nil {
		out.Person.Fullname += " " + *in.Patronymic
	}

	if in.IsFormularsReady() {
		out.Formulars = NewFormulars(in.GetFormulars())
	}

	return
}

func NewPerson(in sdModels11.Person) (out Person) {
	out.Person = in

	if in.IsFormularsReady() {
		out.Formulars = NewFormulars(in.GetFormulars())
	}

	return
}

type People []Person

func NewPeople(in sdModels11.People) (out People) {
	for _, inPerson := range in {
		out = append(out, NewPerson(inPerson))
	}

	return
}

func (people People) ToMap() map[int]*Person {
	personMap := map[int]*Person{}

	for idx, person := range people {
		personMap[person.Id] = &people[idx]
	}

	return personMap
}
